OpenTTD Source: VehicleGroupWindow Class Reference

OpenTTD Source 13.1

Public Member Functions | Static Public Member Functions | Private Types | Private Member Functions | Private Attributes
VehicleGroupWindow Class Reference
Inheritance diagram for VehicleGroupWindow:

## Public Member Functions
| VehicleGroupWindow (WindowDesc *desc, WindowNumber window_number)
void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize) override
| Update size and resize step of a widget in the window. More...
void | OnInvalidateData (int data=0, bool gui_scope=true) override
| Some data on this window has become invalid. More...
void | SetStringParameters (int widget) const override
| Initialize string parameters for a widget. More...
void | OnPaint () override
| The window must be repainted. More...
void | DrawWidget (const Rect &r, int widget) const override
| Draw the contents of a nested widget. More...
void | OnClick (Point pt, int widget, int click_count) override
| A click with the left mouse button has been made on the window. More...
void | OnDragDrop_Group (Point pt, int widget)
void | OnDragDrop_Vehicle (Point pt, int widget)
void | OnDragDrop (Point pt, int widget) override
| A dragged 'object' has been released. More...
void | OnQueryTextFinished (char *str) override
| The query window opened from this window has closed. More...
void | OnResize () override
| Called after the window got resized. More...
void | OnDropdownSelect (int widget, int index) override
| A dropdown option associated to this window has been selected. More...
void | OnGameTick () override
| Called once per (game) tick.
void | OnPlaceObjectAbort () override
| The user cancelled a tile highlight mode that has been set.
void | OnMouseDrag (Point pt, int widget) override
| An 'object' is being dragged at the provided position, highlight the target if possible. More...
void | ShowRenameGroupWindow (GroupID group, bool empty)
void | UnselectVehicle (VehicleID vehicle)
| Tests whether a given vehicle is selected in the window, and unselects it if necessary. More...
void | SelectGroup (const GroupID g_id)
| Selects the specified group in the list. More...
Public Member Functions inherited from BaseVehicleListWindow
| BaseVehicleListWindow (WindowDesc *desc, WindowNumber wno)
void | OnInit () override
| Notification that the nested widget tree gets initialized. More...
void | UpdateSortingFromGrouping ()
void | DrawVehicleListItems (VehicleID selected_vehicle, int line_height, const Rect &r) const
| Draw all the vehicle list items. More...
void | UpdateVehicleGroupBy (GroupBy group_by)
void | SortVehicleList ()
void | BuildVehicleList ()
void | SetCargoFilterIndex (byte index)
| Set cargo filter list item index. More...
void | SetCargoFilterArray ()
| Populate the filter list and set the cargo filter criteria.
void | FilterVehicleList ()
| Filter the engine list against the currently selected cargo filter.
Dimension | GetActionDropdownSize (bool show_autoreplace, bool show_group)
| Compute the size for the Action dropdown. More...
DropDownList | BuildActionDropdownList (bool show_autoreplace, bool show_group)
| Display the Action dropdown window. More...
const StringID * | GetVehicleSorterNames ()
VehicleGroupSortFunction *const * | GetVehicleSorterFuncs ()
Public Member Functions inherited from Window
| Window (WindowDesc *desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class. More...
void * | operator new[] (size_t size)=delete
| Helper allocation function to disallow something. More...
template<class NWID >
const NWID * | GetWidget (uint widnum) const
| Get the nested widget with number widnum from the nested widget tree. More...
template<class NWID >
NWID * | GetWidget (uint widnum)
| Get the nested widget with number widnum from the nested widget tree. More...
const Scrollbar * | GetScrollbar (uint widnum) const
| Return the Scrollbar to a widget index. More...
Scrollbar * | GetScrollbar (uint widnum)
| Return the Scrollbar to a widget index. More...
const QueryString * | GetQueryString (uint widnum) const
| Return the querystring associated to a editbox. More...
QueryString * | GetQueryString (uint widnum)
| Return the querystring associated to a editbox. More...
void | UpdateQueryStringSize ()
| Update size of all QueryStrings of this window.
virtual const char * | GetFocusedText () const
| Get the current input text if an edit box has the focus. More...
virtual const char * | GetCaret () const
| Get the string at the caret if an edit box has the focus. More...
virtual const char * | GetMarkedText (size_t *length) const
| Get the range of the currently marked input text. More...
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus. More...
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus. More...
virtual const char * | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box. More...
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use. More...
void | CreateNestedTree (bool fill_nested=true)
| Perform the first part of the initialization of a nested widget tree. More...
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree. More...
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (byte widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget. More...
bool | IsWidgetHighlighted (byte widget_index) const
| Gets the highlighted status of a widget. More...
void | SetWidgetDisabledState (byte widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget. More...
void | DisableWidget (byte widget_index)
| Sets a widget to disabled. More...
void | EnableWidget (byte widget_index)
| Sets a widget to Enabled. More...
bool | IsWidgetDisabled (byte widget_index) const
| Gets the enabled/disabled status of a widget. More...
bool | IsWidgetFocused (byte widget_index) const
| Check if given widget is focused within this window. More...
bool | IsWidgetGloballyFocused (byte widget_index) const
| Check if given widget has user input focus. More...
void | SetWidgetLoweredState (byte widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget. More...
void | ToggleWidgetLoweredState (byte widget_index)
| Invert the lowered/raised status of a widget. More...
void | LowerWidget (byte widget_index)
| Marks a widget as lowered. More...
void | RaiseWidget (byte widget_index)
| Marks a widget as raised. More...
bool | IsWidgetLowered (byte widget_index) const
| Gets the lowered state of a widget. More...
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus. More...
bool | SetFocusedWidget (int widget_index)
| Set focus within this window to the given widget. More...
EventState | HandleEditBoxKey (int wid, WChar key, uint16 keycode)
| Process keypress for editbox widget. More...
virtual void | InsertTextString (int wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget. More...
void | HandleButtonClick (byte widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks. More...
int | GetRowFromWidget (int clickpos, int widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in. More...
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window. More...
void CDECL | SetWidgetsDisabledState (bool disab_stat, int widgets,...)
| Sets the enabled/disabled status of a list of widgets. More...
void CDECL | SetWidgetsLoweredState (bool lowered_stat, int widgets,...)
| Sets the lowered/raised status of a list of widgets. More...
void | SetWidgetDirty (byte widget_index) const
| Invalidate a widget, i.e. More...
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (int widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol. More...
void | CloseChildWindows (WindowClass wc=WC_INVALID) const
| Close all children a window might have in a head-recursive manner. More...
virtual void | Close ()
| Hide the window and all its child windows, and mark them for a later deletion.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0)
| Re-initialize a window, and optionally change its size. More...
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded. More...
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing) More...
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16 sm_width, int16 sm_height, int window_number)
| Compute the initial position of the window. More...
virtual void | OnFocus ()
| Called when window gains focus.
virtual void | OnFocusLost ()
| Called when window loses focus.
virtual EventState | OnKeyPress (WChar key, uint16 keycode)
| A key has been pressed. More...
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed. More...
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed. More...
virtual bool | OnRightClick (Point pt, int widget)
| A click with the right mouse button has been made on the window. More...
virtual void | OnHover (Point pt, int widget)
| The mouse is hovering over a widget in the window, perform an action for it. More...
virtual bool | OnTooltip (Point pt, int widget, TooltipCloseCondition close_cond)
| Event to display a custom tooltip. More...
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling. More...
virtual void | OnMouseOver (Point pt, int widget)
| The mouse is currently moving over the window or has just moved outside of the window. More...
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned. More...
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnHundredthTick ()
| Called once every 100 (game) ticks, or once every 3s, whichever comes last. More...
virtual void | OnRealtimeTick (uint delta_ms)
| Called periodically.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownClose (Point pt, int widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed. More...
virtual void | OnEditboxChanged (int widget)
| The text in an editbox has been edited. More...
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set. More...
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set. More...
virtual bool | OnVehicleSelect (VehicleList::const_iterator begin, VehicleList::const_iterator end)
| The user clicked on a vehicle while HT_VEHICLE has been set. More...
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set. More...
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set. More...
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode. More...
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable? More...
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window. More...
template<>
const NWidgetBase * | GetWidget (uint widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance. More...
void * | operator new[] (size_t size)
| Memory allocator for an array of class instances. More...
void | operator delete (void *ptr)
| Memory release for a single class instance. More...
void | operator delete[] (void *ptr)
| Memory release for an array of class instances. More...

## Static Public Member Functions
static void | DeleteGroupCallback (Window *win, bool confirmed)
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state. More...
static void | DeleteClosedWindows ()
| Delete all closed windows.

## Private Types
enum | ListColumns { VGC_FOLD, VGC_NAME, VGC_PROTECT, VGC_AUTOREPLACE, VGC_PROFIT, VGC_NUMBER, VGC_END }

## Private Member Functions
void | AddChildren (GUIGroupList *source, GroupID parent, int indent)
void | BuildGroupList (Owner owner)
| (Re)Build the group list. More...
uint | ComputeGroupInfoSize ()
| Compute tiny_step_height and column_size. More...
void | DrawGroupInfo (int y, int left, int right, GroupID g_id, int indent=0, bool protection=false, bool has_children=false) const
| Draw a row in the group list. More...
void | DirtyHighlightedGroupWidget ()
| Mark the widget containing the currently highlighted group as dirty.

## Private Attributes
GroupID | group_sel
| Selected group (for drag/drop)
GroupID | group_rename
| Group being renamed, INVALID_GROUP if none.
GroupID | group_over
| Group over which a vehicle is dragged, INVALID_GROUP if none.
GroupID | group_confirm
| Group awaiting delete confirmation.
GUIGroupList | groups
| List of groups.
uint | tiny_step_height
| Step height for the group list.
Scrollbar * | group_sb
std::vector< int > | indents
| Indentation levels.
Dimension | column_size [VGC_END]
| Size of the columns in the group list.

## Additional Inherited Members
Public Types inherited from BaseVehicleListWindow
enum | GroupBy : byte { GB_NONE, GB_SHARED_ORDERS, GB_END }
enum | CargoFilterSpecialType { CF_NONE = CT_INVALID, CF_ANY = CT_NO_REFIT, CF_FREIGHT = CT_AUTO_REFIT }
| Special cargo filter criteria. More...
enum | ActionDropdownItem { ADI_REPLACE, ADI_SERVICE, ADI_DEPOT, ADI_ADD_SHARED, ADI_REMOVE_ALL }
typedef GUIVehicleGroupList::SortFunction | VehicleGroupSortFunction
typedef GUIVehicleList::SortFunction | VehicleIndividualSortFunction
Public Types inherited from Window
using | IteratorToFront = WindowIterator< false >
| Iterate in Z order towards front.
using | IteratorToBack = WindowIterator< true >
| Iterate in Z order towards back.
using | Iterate = AllWindows< false >
| Iterate all windows in whatever order is easiest.
using | IterateFromBack = AllWindows< false >
| Iterate all windows in Z order from back to front.
using | IterateFromFront = AllWindows< true >
| Iterate all windows in Z order from front to back.
Data Fields inherited from BaseVehicleListWindow
GroupBy | grouping
| How we want to group the list.
VehicleList | vehicles
| List of vehicles. This is the buffer for `vehgroups` to point into; if this is structurally modified, `vehgroups` must be rebuilt.
GUIVehicleGroupList | vehgroups
| List of (groups of) vehicles. This stores iterators of `vehicles`, and should be rebuilt if `vehicles` is structurally changed.
Listing * | sorting
| Pointer to the vehicle type related sorting.
byte | unitnumber_digits
| The number of digits of the highest unit number.
Scrollbar * | vscroll
VehicleListIdentifier | vli
| Identifier of the vehicle list we want to currently show.
VehicleID | vehicle_sel
| Selected vehicle.
CargoID | cargo_filter [NUM_CARGO+3]
| Available cargo filters; CargoID or CF_ANY or CF_FREIGHT or CF_NONE.
StringID | cargo_filter_texts [NUM_CARGO+4]
| Texts for filter_cargo, terminated by INVALID_STRING_ID.
byte | cargo_filter_criteria
| Selected cargo filter index.
uint | order_arrow_width
| Width of the arrow in the small order list.
Data Fields inherited from Window
WindowDesc * | window_desc
| Window description.
WindowFlags | flags
| Window flags.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
uint8 | timeout_timer
| Timer value of the WF_TIMEOUT for flags.
uint8 | white_border_timer
| Timer value of the WF_WHITE_BORDER for flags.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `nullptr` if no nested widget has focus.
SmallMap< int, QueryString * > | querystrings
| QueryString associated to WWT_EDITBOX widgets.
NWidgetBase * | nested_root
| Root of the nested tree.
NWidgetBase ** | nested_array
| Array of pointers into the tree. Do not access directly, use Window::GetWidget() instead.
uint | nested_array_size
| Size of the nested array.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `nullptr`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
int | mouse_capture_widget
| Widgetindex of current mouse capture widget (e.g. dragged scrollbar). -1 if no widget has mouse capture.
Window * | parent
| Parent window.
WindowList::iterator | z_position
Static Public Attributes inherited from BaseVehicleListWindow
static const StringID | vehicle_depot_name []
static const StringID | vehicle_group_by_names []
static const StringID | vehicle_group_none_sorter_names []
static const StringID | vehicle_group_shared_orders_sorter_names []
static VehicleGroupSortFunction *const | vehicle_group_none_sorter_funcs []
static VehicleGroupSortFunction *const | vehicle_group_shared_orders_sorter_funcs []
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window. More...
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window. More...
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size. More...
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
Protected Attributes inherited from Window
std::vector< int > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.

## Detailed Description

Definition at line 113 of file group_gui.cpp.

## Member Enumeration Documentation

## ◆ ListColumns

enum VehicleGroupWindow::ListColumns
| private

Enumerator
VGC_FOLD | Fold / Unfold button.
VGC_NAME | Group name.
VGC_PROTECT | Autoreplace protect icon.
VGC_AUTOREPLACE | Autoreplace active icon.
VGC_PROFIT | Profit icon.
VGC_NUMBER | Number of vehicles in the group.

Definition at line 116 of file group_gui.cpp.

## Member Function Documentation

## ◆ BuildGroupList()

void VehicleGroupWindow::BuildGroupList | ( | Owner | owner | ) |
| inlineprivate

(Re)Build the group list.

Parameters

  owner | The owner of the window

Definition at line 161 of file group_gui.cpp.

References GUIList< T, F >::ForceResort(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_group_pool >::Iterate(), GUIList< T, F >::NeedRebuild(), Window::owner, SetDParam(), and GUIList< T, F >::Sort().

Referenced by OnPaint(), and SelectGroup().

## ◆ ComputeGroupInfoSize()

uint VehicleGroupWindow::ComputeGroupInfoSize | ( |  | ) |
| inlineprivate

Compute tiny_step_height and column_size.

Returns
  Total width required for the group list.

Definition at line 209 of file group_gui.cpp.

References GetSpriteSize(), maxdim(), and VGC_FOLD.

Referenced by UpdateWidgetSize().

## ◆ DrawGroupInfo()

void VehicleGroupWindow::DrawGroupInfo | ( | int | y,
|  | int | left,
|  | int | right,
|  | GroupID | g_id,
|  | int | indent = `0`,
|  | bool | protection = `false`,
|  | bool | has_children = `false`
| ) |  | const
| inlineprivate

Draw a row in the group list.

Parameters

  y | Top of the row.
  left | Left of the row.
  right | Right of the row.
  g_id | Group to list.
  indent | Indentation level.
  protection | Whether autoreplace protection is set.
  has_children | Whether the group has children and should have a fold / unfold button.

Definition at line 261 of file group_gui.cpp.

Referenced by DrawWidget().

## ◆ DrawWidget()

void VehicleGroupWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget
| ) |  | const
| inlineoverridevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 561 of file group_gui.cpp.

References ALL_GROUP, DEFAULT_GROUP, DrawGroupInfo(), DrawString(), WidgetDimensions::scaled, Rect::Shrink(), BaseVehicleListWindow::vehicles, WID_GL_ALL_VEHICLES, WID_GL_DEFAULT_VEHICLES, and WID_GL_INFO.

## ◆ OnClick()

void VehicleGroupWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count
| ) |  |
| inlineoverridevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 657 of file group_gui.cpp.

References ALL_GROUP, BaseVehicleListWindow::cargo_filter_criteria, BaseVehicleListWindow::cargo_filter_texts, GUIList< T, F >::ForceRebuild(), BaseVehicleListWindow::grouping, VehicleListIdentifier::index, IsAllGroupID(), Window::SetDirty(), ShowDropDownMenu(), GUIList< T, F >::SortType(), GUIList< T, F >::ToggleSortOrder(), VEH_ROAD, VEH_TRAIN, BaseVehicleListWindow::vehgroups, BaseVehicleListWindow::vli, WID_GL_ALL_VEHICLES, WID_GL_DEFAULT_VEHICLES, WID_GL_FILTER_BY_CARGO, WID_GL_GROUP_BY_DROPDOWN, WID_GL_SORT_BY_DROPDOWN, and WID_GL_SORT_BY_ORDER.

## ◆ OnDragDrop()

void VehicleGroupWindow::OnDragDrop | ( | Point | pt,
|  | int | widget
| ) |  |
| inlineoverridevirtual

A dragged 'object' has been released.

Parameters

  pt | the point inside the window where the release took place.
  widget | the widget where the release took place.

Reimplemented from Window.

Definition at line 929 of file group_gui.cpp.

References INVALID_GROUP, INVALID_VEHICLE, and BaseVehicleListWindow::vehicle_sel.

## ◆ OnDropdownSelect()

void VehicleGroupWindow::OnDropdownSelect | ( | int | widget,
|  | int | index
| ) |  |
| inlineoverridevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 949 of file group_gui.cpp.

References VehicleListIdentifier::index, BaseVehicleListWindow::SetCargoFilterIndex(), GUIList< T, F >::SetSortType(), ShowReplaceGroupVehicleWindow(), BaseVehicleListWindow::vehgroups, BaseVehicleListWindow::vehicles, BaseVehicleListWindow::vli, WID_GL_FILTER_BY_CARGO, WID_GL_GROUP_BY_DROPDOWN, WID_GL_MANAGE_VEHICLES_DROPDOWN, and WID_GL_SORT_BY_DROPDOWN.

## ◆ OnInvalidateData()

void VehicleGroupWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlineoverridevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 445 of file group_gui.cpp.

References CloseWindowByClass(), GUIList< T, F >::ForceRebuild(), GUIList< T, F >::ForceResort(), VehicleListIdentifier::index, INVALID_GROUP, IsAllGroupID(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_group_pool >::IsValidID(), BaseVehicleListWindow::vehgroups, BaseVehicleListWindow::vli, and WC_QUERY_STRING.

## ◆ OnMouseDrag()

void VehicleGroupWindow::OnMouseDrag | ( | Point | pt,
|  | int | widget
| ) |  |
| inlineoverridevirtual

An 'object' is being dragged at the provided position, highlight the target if possible.

Parameters

  pt | The point inside the window that the mouse hovers over.
  widget | The widget the mouse hovers over.

Reimplemented from Window.

Definition at line 1014 of file group_gui.cpp.

References DEFAULT_GROUP, DirtyHighlightedGroupWidget(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_vehicle_pool >::Get(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_group_pool >::Get(), Scrollbar::GetScrolledRowFromWidget(), INVALID_GROUP, INVALID_VEHICLE, NEW_GROUP, Window::parent, BaseVehicleListWindow::vehicle_sel, WID_GL_DEFAULT_VEHICLES, and WID_GL_LIST_GROUP.

## ◆ OnPaint()

void VehicleGroupWindow::OnPaint | ( |  | ) |
| inlineoverridevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 500 of file group_gui.cpp.

References _local_company, BuildGroupList(), HideDropDownMenu(), Window::owner, Window::RaiseWidget(), Scrollbar::SetCount(), Window::SetWidgetsDisabledState(), BaseVehicleListWindow::vehgroups, BaseVehicleListWindow::vehicles, WID_GL_MANAGE_VEHICLES_DROPDOWN, WID_GL_START_ALL, WID_GL_STOP_ALL, and WIDGET_LIST_END.

## ◆ OnQueryTextFinished()

void VehicleGroupWindow::OnQueryTextFinished | ( | char * | str | ) |
| inlineoverridevirtual

The query window opened from this window has closed.

Parameters

  str | the new value of the string, nullptr if the window was cancelled or an empty string when the default button was pressed, i.e. StrEmpty(str).

Reimplemented from Window.

Definition at line 937 of file group_gui.cpp.

References INVALID_GROUP, and Rename.

## ◆ OnResize()

void VehicleGroupWindow::OnResize | ( |  | ) |
| inlineoverridevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 943 of file group_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), WID_GL_LIST_GROUP, and WID_GL_LIST_VEHICLE.

## ◆ SelectGroup()

void VehicleGroupWindow::SelectGroup | ( | const GroupID | g_id | ) |
| inline

Selects the specified group in the list.

Parameters

  g_id | The ID of the group to be selected

Definition at line 1075 of file group_gui.cpp.

References ALL_GROUP, BuildGroupList(), DEFAULT_GROUP, find_index(), GUIList< T, F >::ForceRebuild(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_group_pool >::Get(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_group_pool >::GetIfValid(), VehicleListIdentifier::index, INVALID_GROUP, Window::owner, Group::parent, Scrollbar::ScrollTowards(), Scrollbar::SetCount(), Window::SetDirty(), BaseVehicleListWindow::vehgroups, and BaseVehicleListWindow::vli.

## ◆ SetStringParameters()

void VehicleGroupWindow::SetStringParameters | ( | int | widget | ) | const
| inlineoverridevirtual

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.

Reimplemented from Window.

Definition at line 469 of file group_gui.cpp.

References BaseVehicleListWindow::cargo_filter_criteria, BaseVehicleListWindow::cargo_filter_texts, SetDParam(), BaseVehicleListWindow::vli, VehicleListIdentifier::vtype, WID_GL_AVAILABLE_VEHICLES, WID_GL_CAPTION, and WID_GL_FILTER_BY_CARGO.

## ◆ UnselectVehicle()

void VehicleGroupWindow::UnselectVehicle | ( | VehicleID | vehicle | ) |
| inline

Tests whether a given vehicle is selected in the window, and unselects it if necessary.

Called when the vehicle is deleted.

Parameters

  vehicle | Vehicle that is going to be deleted

Definition at line 1065 of file group_gui.cpp.

References ResetObjectToPlace(), and BaseVehicleListWindow::vehicle_sel.

Referenced by DeleteGroupHighlightOfVehicle().

## ◆ UpdateWidgetSize()

void VehicleGroupWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize
| ) |  |
| inlineoverridevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  widget | Widget number.
  size | Size of the widget.
  padding | Recommended amount of space between the widget content and the widget edge.
  fill | Fill step of the widget.
  resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 387 of file group_gui.cpp.

References BaseVehicleListWindow::cargo_filter_texts, ComputeGroupInfoSize(), BaseVehicleListWindow::GetActionDropdownSize(), GetStringBoundingBox(), GetStringListWidth(), GetVehicleListHeight(), maxdim(), Window::resize, Window::SortButtonWidth(), tiny_step_height, BaseVehicleListWindow::vli, VehicleListIdentifier::vtype, WID_GL_ALL_VEHICLES, WID_GL_DEFAULT_VEHICLES, WID_GL_FILTER_BY_CARGO, WID_GL_GROUP_BY_DROPDOWN, WID_GL_LIST_GROUP, WID_GL_LIST_VEHICLE, WID_GL_MANAGE_VEHICLES_DROPDOWN, WID_GL_SORT_BY_DROPDOWN, and WID_GL_SORT_BY_ORDER.

The documentation for this class was generated from the following file:

- src/group_gui.cpp